Page MenuHomePhabricator

Deploy structured wikitext mentor list to Wikimedia wikis
Open, MediumPublic

Description

Background

As part of T264343: Have a special page for mentors to sign up, the Growth team is working on a sign up form for mentors. We decided to create a structured mentor list, MediaWiki:GrowthMentors.json, to serve as the new canonical location for the list of mentors, similar to what community configuration does.

Task objective

Deploy the structured mentor list to Wikimedia wikis. This has to be done carefully, because it will be difficult to go back once we do the deployment.

Deployment checklist
Prerequisites
  • Write a migration script (T310446)
  • Wait until code is ready to adequately support the structured mentor list (currently tracked under T264343)
Testing the structured mentor list
  • Temporarily allow all beta users to enroll as mentors for testing purposes (patch)
  • Make beta enwiki use structured mentor list (patch)
  • Run mwscript extensions/GrowthExperiments/maintenance/migrateWikitextMentorList.php --wiki=enwiki at beta cluster
  • Thoroughly test the structured mentor list at beta enwiki (T312102)
  • Make beta arwiki use structured mentor list (patch)
  • Run mwscript extensions/GrowthExperiments/maintenance/migrateWikitextMentorList.php --wiki=arwiki at beta cluster
  • Habib (Arabic Ambassador) tests the structured mentor list at arwiki
Migration
  • Review existing wikitext mentor lists for inconsistencies, bugs, etc. (T310906)
  • Switch beta cluster + testwiki to structured mentor list (substeps have to be done at once; beta patch, testwiki patch)
    • Set $wgGEMentorProvider = "structured" for all affected wikis
    • Run mwscript extensions/GrowthExperiments/maintenance/migrateWikitextMentorList.php --wiki=XXwiki for all affected wikis
  • Thoroughly QA behavior with the structured mentor list at those wikis; ask Ambassadors to review the interface
  • Document the new interface.
  • Announce the migration to the pilot wikis, inform them about the impact
  • Switch the pilot wikis to structured mentor list (substeps have to be done at once; point of no return; patch)
    • Set $wgGEMentorProvider = "structured" for all affected wikis
    • Run mwscript extensions/GrowthExperiments/maintenance/migrateWikitextMentorList.php --wiki=XXwiki for all affected wikis
  • Wait 1 week for possible issues
  • Address all raised issues
  • Announce the migration to the rest of the wikis, inform them about the impact
  • Switch all remaining wikis to structured mentor list (substeps have to be done at once; point of no return)
    • Set $wgGEMentorProvider = "structured" for all affected wikis
    • Run mwscript extensions/GrowthExperiments/maintenance/migrateWikitextMentorList.php --wiki=XXwiki for all affected wikis
Clean up
  • Remove code supporting the wikitext-based mentor list

Event Timeline

Urbanecm_WMF updated the task description. (Show Details)
Urbanecm_WMF updated the task description. (Show Details)

Change 808267 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Add GEMentorProvider to configuration

https://gerrit.wikimedia.org/r/808267

Change 808268 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] [beta] Growth: Enable structured mentor list at cswiki

https://gerrit.wikimedia.org/r/808268

Change 808269 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] [beta] Growth: Switch to structured mentor list at all wikis

https://gerrit.wikimedia.org/r/808269

Change 808267 merged by jenkins-bot:

[operations/mediawiki-config@master] Add GEMentorProvider to configuration

https://gerrit.wikimedia.org/r/808267

Mentioned in SAL (#wikimedia-operations) [2022-06-29T07:55:50Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: 5a583804: Add GEMentorProvider to configuration (T310905) (duration: 03m 40s)

Change 810452 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] [beta] Temporarily allow everyone to enroll as mentor

https://gerrit.wikimedia.org/r/810452

Change 810452 merged by jenkins-bot:

[operations/mediawiki-config@master] [beta] Temporarily allow everyone to enroll as mentor

https://gerrit.wikimedia.org/r/810452

Change 808268 merged by jenkins-bot:

[operations/mediawiki-config@master] [beta] Growth: Enable structured mentor list at enwiki

https://gerrit.wikimedia.org/r/808268

Change 815331 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] [beta] Growth: Enable structured mentor list at arwiki

https://gerrit.wikimedia.org/r/815331

Change 815331 merged by jenkins-bot:

[operations/mediawiki-config@master] [beta] Growth: Enable structured mentor list at arwiki

https://gerrit.wikimedia.org/r/815331

Mentioned in SAL (#wikimedia-releng) [2022-07-19T17:00:45Z] <urbanecm> deployment-prep: urbanecm@deployment-mwmaint02:~$ mwscript extensions/GrowthExperiments/maintenance/migrateWikitextMentorList.php --wiki=arwiki # T310905

Change 819053 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] testwiki: Growth: Switch to structured mentor list

https://gerrit.wikimedia.org/r/819053

Change 819054 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Growth: Switch pilot wikis to structured mentor list

https://gerrit.wikimedia.org/r/819054

Change 808269 merged by jenkins-bot:

[operations/mediawiki-config@master] [beta] Growth: Switch to structured mentor list at all wikis

https://gerrit.wikimedia.org/r/808269

Change 819053 merged by jenkins-bot:

[operations/mediawiki-config@master] testwiki: Growth: Switch to structured mentor list

https://gerrit.wikimedia.org/r/819053

Mentioned in SAL (#wikimedia-operations) [2022-08-04T09:26:35Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: 0614a39bf15252c95a96565dd7c986237f3d3323: testwiki: Growth: Switch to structured mentor list (T310905) (duration: 03m 38s)

Change 820392 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] testwiki: Growth: Assign enrollasmentor to *

https://gerrit.wikimedia.org/r/820392

Change 820392 merged by jenkins-bot:

[operations/mediawiki-config@master] testwiki: Growth: Assign enrollasmentor to *

https://gerrit.wikimedia.org/r/820392

Mentioned in SAL (#wikimedia-operations) [2022-08-04T09:35:31Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: ddcd333015bb58a98709a5005a5db7e8519dd0a5: testwiki: Growth: Assign enrollasmentor to * (T310905) (duration: 03m 41s)